unit Splash;
{Version 2.0}
{
 Copyright 1996 By Amber Computer Systems Inc.
 and Dave Robinson
 14197 74 Ave Surrey BC
 Ph. 604 599-9279
 FAX 604 599-9261
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trebuild, ComCtrls, Gauges, ExtCtrls, StdCtrls, DB;

type
  TSplashScreen = class(TForm)
    panelRebProgress: TPanel;
    GaugeRebProgress: TGauge;
    StatusBarRebProgress: TStatusBar;
    Rebuilder: TRebuilder;
    Panel1: TPanel;
    Label1: TLabel;
    DisplayStructureAlias: TEdit;
    DisplayTestAlias: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RebuilderNextTableTest(TestingTableName: string; TableNo,
      TableCount: Integer; IsReb: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SplashScreen: TSplashScreen;

implementation

{$R *.DFM}

Type
    TestInvalid = class(Exception);

{***************************************************************}
procedure TSplashScreen.FormActivate(Sender: TObject);

{***  private procedure for form activate  *********************}
Procedure Rebuilding(tAliasName, sAliasName: String);
Var
  AliasParams : TStrings;
  TestDir, StructureDir: String;

Begin
  AliasParams:=TStringList.create;
  Try
    StatusBarRebProgress.Panels.Items[0].Text := tAliasName;
    PanelRebProgress.refresh;
    Rebuilder.ProtectedAlias := tAliasName;
    Rebuilder.BackupStrAlias := sAliasName;

    Session.GetAliasNames(AliasParams);
    If AliasParams.IndexOf(Rebuilder.ProtectedAlias)<0 then
      Begin
      screen.cursor:=crDefault;
      raise TestInvalid.Create('Unable to locate test alias, '+Rebuilder.ProtectedAlias);
      end;
    If AliasParams.IndexOf(Rebuilder.BackupStrAlias)<0 then
      Begin
      screen.cursor:=crDefault;
      raise TestInvalid.Create('Unable to locate structure alias, '+Rebuilder.BackupStrAlias);
      end;

    Session.GetAliasParams(Rebuilder.ProtectedAlias, AliasParams);
    TestDir:=Copy(AliasParams.Strings[0],6,60);
    Session.GetAliasParams(Rebuilder.BackupStrAlias, AliasParams);
    StructureDir:=Copy(AliasParams.Strings[0],6,60);

    If UpperCase(TestDir)<>UpperCase(StructureDir) then
      Rebuilder.checkAlias
    else
      Begin
      screen.cursor:=crDefault;
      raise TestInvalid.Create('Test alias and structure alias must not be pointing to the same directory.');
      end;
  Finally
    AliasParams.Free;
  end;
end;

{***  form activate main procedure *****************************}
begin
  Application.ProcessMessages;
  Rebuilder.UseTUtilForTest:=True; {better testing but slow on large tables}
  Rebuilding(DisplayTestAlias.Text, DisplayStructureAlias.Text);
  Rebuilder.UseTUtilForTest:=False; {faster}

  { Place more tests here }

end;



{***************************************************************}
{***  close form  **********************************************}
procedure TSplashScreen.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  screen.cursor:=crDefault;
end;



{***************************************************************}
{***  Advance gauge, table counter, etc..  *********************}
procedure TSplashScreen.RebuilderNextTableTest(TestingTableName: string; TableNo,
  TableCount: Integer; IsReb: Boolean);
begin
  GaugeRebProgress.maxvalue := Tablecount;
  GaugeRebProgress.progress := TableNo;
  if Isreb then
    begin
    GaugeRebProgress.ForeColor := clRed;
    StatusBarRebProgress.Panels.Items[1].Text := ' Rebuilding table ' + TestingTableName;
    end
  else
    Begin
    GaugeRebProgress.ForeColor := clGreen;
    StatusBarRebProgress.Panels.Items[1].Text := ' Testing table ' + TestingTableName;
    end;
  PanelRebProgress.refresh;
end;

{***  End Program  *********************************************}
end.
